package entity

import (
	"code.30cm.net/digimon/app-cloudep-comment-server/pkg/domain/comment"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

// Comments 只有一層的回應，沒有巢狀回覆
type Comments struct {
	ID              primitive.ObjectID `bson:"_id,omitempty"`     // MongoDB 的 ObjectID
	UID             string             `bson:"uid"`               // 留言的使用者的 ID
	ReferenceID     string             `bson:"reference_id"`      // 參考的 id，例如 product_id
	ParentCommentID string             `bson:"parent_comment_id"` // 父留言 id，沒有就空白
	Message         string             `bson:"message"`           // 留言內容
	Level           comment.Level      `bson:"level"`             // 等級，數字較小的為上層
	IsVisitable     bool               `bson:"is_visitable"`      // 是否隱藏
	UpdatedAt       int64              `bson:"updated_at"`        // 更新時間
	CreatedAt       int64              `bson:"created_at"`        // 建立時間
}

func (c *Comments) CollectionName() string {
	return "comments"
}
